

#define RATE    0.052
#define Long    1.0
#define ENTER   0
#define EXIT    1
#define MOT_NUM 4
#define MOTDRIVER_WAIT  300 //ms
#define BAUD_RATE       115200
#define ON      1
#define OFF     0

#define MOT1    1.0
#define MOT2    1.0
#define MOT3    1.0
#define MOT4    1.0

#define OUT_LIMIT   30.0
#define MAX_POW     100
#define MIN_POW     -100

DigitalOut led1(LED1); 
DigitalOut led2(LED2);
DigitalOut led3(LED3);
DigitalOut led4(LED4);
HMC6352 compass(p9, p10);
Serial driver(p28, p27); // tx, rx 
Serial pc(USBTX, USBRX); // tx, rx 
DigitalIn StartButton(p21);
DigitalIn CalibEnterButton(p22);
DigitalIn CalibExitButton(p23);
PID pid(0.59, 1.0, 0.015, RATE);      //30.0 0.35 1.0 0.012 30.0 0.42 1.0 0.013 
Ticker pidUpdata;
Ticker IR;
Ticker ultrasonic;
Timer timer1;
Timer timer2;
Timer timer_ir;     /* 赤外線用タイマー */


int speed[MOT_NUM] = {0};
 
static float lastData = 0.0;
static float inputPID = 180.0;
static float standard;
static float compassPID = 0.0;

extern string StringFIN;

extern int direction;
extern int Distance;
extern int IR_found;
extern double ball_sankaku[16][2];
extern double ultrasonicVal[3];

extern void Ultrasonic(void);
extern void IR_Position(void);
extern void PidUpdata(void);
extern void array(int,int,int,int);

enum{
    HOME_WAIT,
    DIFFENCE,
};

